﻿-----------------------------------------------------------------------------------------
--Debuffs Group Frame--------------------------------------------------------------------
-----------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))
local LSM = LibStub("LibSharedMedia-3.0")

local UnitDebuff = UnitDebuff
local UnitGUID = UnitGUID
local UnitName = UnitName
local UnitIsEnemy = UnitIsEnemy
local GetTime = GetTime
local IsAddOnLoaded = IsAddOnLoaded
local pairs = pairs
local unpack = unpack
local bit_band = bit.band
local COMBATLOG_OBJECT_REACTION_FRIENDLY = COMBATLOG_OBJECT_REACTION_FRIENDLY
local COMBATLOG_OBJECT_REACTION_NEUTRAL = COMBATLOG_OBJECT_REACTION_NEUTRAL

function SN:SetupDB()
	F.debuffs = T:NewGroup(SN.data.profile.debuffs.width, "Debuff Frame", debuffs, M.media.draghandle)
	F.debuffs:SetSorting("label")
	F.debuffs:SetSpacing(0, 3)
	F.debuffs:SetStartPoint(SN.data.profile.debuffs.grow)
	F.debuffs:SetPoint(unpack(SN.data.profile.frames.debuffs))

	if SN.data.profile.debuffs.iconmode then
		F.debuffs:SetIconMode(32 * SN.data.profile.debuffs.iconscale, "BOTTOM", 0, 0)
		F.debuffs:SetSpacing(SN.data.profile.debuffs.fontsize / 2, SN.data.profile.debuffs.fontsize + 3)
	end
	F.debuffs:SetScript("OnEvent", function(self, event, ...)
		SN:DebuffEvents(self, event, ...)
	end)
		
	--Register our events for the frame
	
	if not SN.data.profile.debuffs.enable then
		SN:DebuffDisable()
	else
		SN:DebuffEnable()
	end

end

function SN:DebuffEnable()
	F.debuffs:Show()
	F.debuffs:RegisterUnitEvent("UNIT_AURA", "target")
	F.debuffs:RegisterEvent("PLAYER_TARGET_CHANGED")
	collectgarbage("collect")
end

function SN:DebuffDisable()
	F.debuffs:UnregisterAllEvents()
	F.debuffs:Hide()
	collectgarbage("collect")
end

function SN:DebuffEvents(self, event, ...)

	local bars = self.bars
	if self.bars then
		for i in pairs(bars) do
			if i:GetData("SN:arg3") ~= UnitGUID("target") then
				i:Stop()
			end
		end
	end
	local i = 1
	while true do
		local name, _, _, _, _, dur, expirationTime, sourceName, _, _, spellId, canApplyAura = UnitDebuff("target", i)
		--Is there a bar for this debuff already?
		if not name then break end

		if sourceName == "player" then
			if not tContains(SN.crowdcontrol, spellId) then
				local dbf = self:Find("SN:arg5", name)
				if dbf == nil and expirationTime ~= nil then
					if dur == 0 and expirationTime == 0 then
						SN:CreateBar(self, spellId, 9999, UnitName(sourceName), UnitGUID("target"), name,
						SN.data.profile.debuffs.width, SN.data.profile.debuffs.height, SN.data.profile.debuffs.fontsize, LSM:Fetch("font", SN.data.profile.debuffs.font),
								LSM:Fetch("statusbar", SN.data.profile.debuffs.texture))
					else
						SN:CreateBar(self, spellId, (expirationTime - GetTime()), UnitName(sourceName), UnitGUID("target"), name,
						SN.data.profile.debuffs.width, SN.data.profile.debuffs.height, SN.data.profile.debuffs.fontsize, LSM:Fetch("font", SN.data.profile.debuffs.font),
								LSM:Fetch("statusbar", SN.data.profile.debuffs.texture))
					end
					for i in pairs(bars) do
						if i:GetData("SN:arg2") == spellId and i:GetData("SN:arg3") == UnitGUID("target") then
							if expirationTime == 0 and dur == 0 then
								i:SetDuration(9999)
								i.FB_Duration:Hide()
							else
								i:SetDuration((expirationTime - GetTime()), dur)
							end
							i:Start()
						end
					end
				elseif dbf ~= nil then
					dbf:SetDuration((expirationTime - GetTime()), dur)
					dbf:Start()
				end
			end
		end
		i = i + 1
	end
end